<?php
/*

 $Id: subnet.php,v 1.14 2003/09/09 16:53:16 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/subnet.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Subnet Document
	Create/edit/delete Subnets.
*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);

	$conf['script'] = "subnet.php";

/* End House Keeping */

// Only admins and zone admins should be here
if ( ! $user->is_admin ) {
        header("Location: " . $conf['web_path'] . "/index.php");
	exit();
}

// process any submits that may come our way
$title = "Subnet Information";

// need this object for doing the IP math
$ip = new IP (0);
$subnet = new Subnet($subnet_id);

//Show the Header
show_template('header');
echo "<font class=\"header1\"><?= $title ?></font>\n";

/**********************
     WORK IF BLOCK 
**********************/

// first let's check the data for Create/Update
if ( $action == 'Create' || $action == 'Update' ) {
	//We have netmask broken into 4 select statements patch the mojo back togeather
	$netmask = implode(".",$netmask);

	// uh-oh, at least type something
	if ( !$name && !$subnet_mask && !$netmask && !$status && !$router ) {
		$conf['error']->add_error('subnet_top', "Please enter values for the form.");
	}

	// check the ip field for validity (\d+.\d+.\d+.\d+)
	if ( !preg_match("/\d+\.\d+\.\d+\.\d+/", $subnet_mask) ) {
		$conf['error']->add_error('subnet_subnet', "Please enter a valid subnet mask.");
	}

	if ( !preg_match("/\d+\.\d+\.\d+\.\d+/", $netmask) ) {
		$conf['error']->add_error('subnet_netmask', "Please enter a valid netmask.");
	}

	if ( !preg_match("/\d+\.\d+\.\d+\.\d+/", $router) ) {
		$conf['error']->add_error('subnet_router', "Please enter a valid router.");
	}

	// now check to see that both the start & end ip's for this subnet are
	//   in the database 

	$subnet_int = $ip->ip2int($subnet_mask);
	$netmask_int = $ip->ip2int($netmask);

	$subnet_end = $subnet->get_end($subnet_int,$netmask_int);

	if (! ($ip->ip_exists($subnet_int) AND $ip->ip_exists($subnet_end) )  ) {
		$conf['error']->add_error('subnet_top', "Sorry, that IP address range isn't in the database.  Please use the IP address addition tool to add that IP range.");
	}

	//Next check to make sure this isn't overlapping with any of the other subnets
	$subnet_id = $subnet->check_overlap($subnet_int,$subnet_end);
	
	//If found then set the error
	if ($subnet_id) {
		$error = "Sorry, the subnet you are trying to create overlaps with one ore more subnets.  ".
				"<a href=\"/subnet.php?action=edit&subnet_id=$result->subnet\">View the overlapping ".
				"subnet</a>.";
		$conf['error']->add_error('subnet_top', $error);
	}
}

//Create the subnet 
if ( $action == 'Create' ) {

	//If an error occured above then... 
	if ( $conf['error']->error_state ) {		
		$action = 'show_create';
	}
	//We are good create the subnet
	else {
		$subnet_mask = $ip->ip2int($subnet_mask);
		$netmask = $ip->ip2int($netmask);
		$router = $ip->ip2int($router);

		$sql = "INSERT INTO subnet (name,subnet,netmask,router,status) ".
			"VALUES ('$name',$subnet_mask,$netmask, $router, '$status')";
		$db_result = mysql_query($sql, $conf['dbh']);	
		$subnet_id = mysql_insert_id($conf['dbh']);
		
		//Display the confirmation
		if ($wizard) { $link = $conf['web_path'] . "/admin.php?action=new_network&amp;last_step=1&amp;subnet_id=$subnet_id"; }
		else { $link = $conf['web_path'] . "/subnet.php?action=edit&amp;subnet_id=$subnet_id"; }
		$conf['ui']->display_confirmation("Subnet Created","Your Subnet has been created.",$link);

	}

} //action == 'Create'

//let's updated it
if ( $action == 'Update' ) {

	//If there was a error go back to the edit mojo
	if ( $conf['error']->error_state ) {
		// there was an error so set the appropriate action
		$action = 'edit';
	}
	//Woohoo were bad mojo free, let's go for the update.
	else {

		//Convert from dotted quad to int form.
                $subnet_mask = $ip->ip2int($subnet_mask);
                $netmask     = $ip->ip2int($netmask);
                $router      = $ip->ip2int($router);

		//Start updating the items
		$subnet->update_name($name);
		$subnet->update_subnet($subnet_mask);
		$subnet->update_netmask($netmask);
		$subnet->update_router($router);
		$subnet->update_status($status);
		$subnet->object_history->update($user->username,$comment);
		$conf['ui']->display_confirmation("Subnet Updated", "The Subnet has been updated succesfully",$conf['web_path'] . "/subnet.php?action=edit&amp;subnet_id=$subnet->id");
	}

} // action == update


// this we're really deleting this zone
elseif ( $action == 'delete' && $really ) {
	$sql = "DELETE FROM subnet WHERE id=$subnet_id";
	$db_result = mysql_query($sql, $conf['dbh']);

	$action = 'show_subnets';
	$conf['action'] = $action;
}
elseif ( $action == 'edit' ) {
		$subnet = new Subnet($subnet_id);
}


/**********************
   DISPLAY IF BLOCK 
**********************/


if ( $action == 'edit' || $action == 'show_create' ) {
	// show the range edit form
	$conf['ui']->show_subnet($action, $subnet);
}
elseif ( $action == 'show_unused_subnets' ) {

        $sql = "SELECT id FROM subnet";

        if (!$user->view) {
                $user->view = new View($sql);
        }

        if ($sort_type) {
                $user->view->initialize($sort_type,$sort_offset);
        }
        else {
                $user->view->initialize('subnet', $sort_offset);
        }

	$s = get_available_subnets();
	$conf['ui']->show_unused_subnets($s);
} //show_unused_subnets

elseif ( $action == 'show_subnets' ) {

        $sql = "SELECT id FROM subnet";

        if (!$user->view) {
                $user->view = new View($sql);
        }

        if ($sort_type) {
                $user->view->initialize($sort_type,$sort_offset);
        }
        else {
                $user->view->initialize('subnet', $sort_offset);
        }

	$subnets = $conf['ui']->get_subnets();
	$conf['ui']->show_subnets('', $subnets);
} //show_subnets

elseif ( $action == 'delete' || $action == 'Delete' ) {
	// show the confirm delete
	$subnet = new Subnet($subnet_id);
	$subnet  = $subnet->subnet->ip_addr;
	$netmask = $subnet->netmask->ip_addr;
	$conf['ui']->show_confirm($conf['web_path'] . "/subnet.php?action=delete&really=1&subnet_id=$subnet_id","Are you sure you want to delete this subnet? <b>($start to $end in $zone->name)</b>");
} //delete

show_template('footer'); 

?>
