<?
/* ----------------------------- CVS INFO --------------------------------

      $Source: /data/cvsroot/libglue/examples/config.php,v $
      last modified by $Author: vollmerk $ at $Date: 2003/09/15 20:17:37 $

 -----------------------------------------------------------------------

 This is the configuration file for libglue.  libglue provides a set of
    libraries for use within applications developed here at
    Oregon State University.  This set of libraries includes a
    session handler, mysql/ldap authentication methods,
    a database handler as well as an error and help
    class.  Include the config, start the session, and session management
    and authentication are all taken care of for you.

 To use this tool simply include this file in your application:

   require '/path/to/this/config.php'; 

 And call check_session:

   check_session();

 For more detailed setup instructions, see the README file.

*/

/* Set this to the path where libglue is stored: */
$libglue_path = "/data/libglue";


$conf = array();

////////////////////////////////////////////////////////////////////////////////
//						
//// Settings for ldap authentication
//// Uncomment the $conf lines and set appropriate values for your setup.
////  Authentication Server:			
//	$conf['ldap_host'] = "ldaps://ldap.example.com/";
////  Distinguished Name:
//	$conf['ldap_dn'] = "uid=joe,ou=subgroup,o=example.com";
//// Search Filter:
//      $conf['ldap_filter'] = "uid=";
////  If you want to connect via Ldap Version 3
//	$conf['ldap_version3'] = true;
////  Ldap password:
//	$conf['ldap_pass'] = "password";
////  Ldap fields to be retrieved and stored with session.
//	$conf['ldap_fields'] = array('cn','homedirectory');
//
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
// Settings for mysql/database authentication
////  Authentication Server:
//	$conf['mysql_host'] = "localhost";
////  Database User Name:
//	$conf['mysql_user'] = "dbuser";
////  Database password:
//	$conf['mysql_pass'] = "dbpass";
////  User table:
//	$conf['mysql_table'] = "user";
////  username column in User table:
//	$conf['mysql_usercol'] = "username";
////  password column in User table:
//	$conf['mysql_passwdcol'] = "password";
////  an extra condition that must be true
//	$conf['mysql_othercol'] = "status='active'";
////  Name of the database to connect to:
//	$conf['mysql_db'] = "databasename";
////  Database fields to be retrieved and stored with sesion.
////  NOT an array.
//	$conf['mysql_fields'] = "id,username,fullname,email,access";
//												
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//																		     
//// Generic Authentication Settings									        
//// Methods to try authetication with, and the order to try them:
//   $conf['auth_methods'] = 'ldap';
//   $conf['auth_methods'] = 'mysql';
//   $conf['auth_methods'] = array('ldap','mysql');

// Empty username/password message:									   
$conf['empty_field'] = "You left one or more fields empty.  Please enter both your username and password to log in.\n";

// Bad (non-user) system credentials message
$conf['bad_auth_cred'] = "Unable to authenticate using this service: This is most likely a configuration mistake by the site administrator.\n";

// User not found
$conf['user_not_found'] = "Username not found.\n";

// Login failed.
$conf['login_failed'] = "Bad username or password.\n";

// Could not connect to server.
$conf['connect_error'] = "Could not connect to authentication server.";

// If this file exists, no one can authenticate:
$conf['stop_auth'] = "/data/libglue/gone.fishing";

// Login page
$conf['login_page'] = "http://oprah.library.oregonstate.edu/login.php";

// Successful Login page
$conf['auth_page'] = "http://oprah.library.oregonstate.edu/";

//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//																		     
// Session Settings;
// Control how this beast behaves after we've authenticated.
//

// Database host for session
//$conf['sess_id_host'] = $conf['mysql_host'];
$conf['sess_host'] = 'localhost';

//// Database where sessions are stored
//$conf['sess_id_db'] = $conf['mysql_db'];
////  or
$conf['sess_db'] = 'session_database';

//// Table where session data is stored
$conf['sess_table'] = 'session';

//// Column where session id's are stored
$conf['sess_idcol'] = 'id';

// Column for session data:
//    We recommend using a large type ('text')
//    until you are sure of how much data you need to store
//    If your session information overflows this field,
//    you will get very strange errors in your apps.
$conf['sess_data'] = "data";

// Column to hold session expiration date
//     should be an 'int' column - we use unix timestamps
$conf['sess_expirecol'] = "expire";

// Account with select/insert/update/delete access to session table:
//
//$conf['sess_user'] = $conf['mysql_user'];
$conf['sess_user'] = 'sess_auth';

// Password for session table account
//
//$conf['sess_id_pass'] = $conf['mysql_pass'];
$conf['sess_pass'] = 'sess_password';



// Session data can optionally be stored in another database
//   This lets applications share a common session across sites
//   but maintain different session data
//   If sess_data_db is empty or commented out,
//     session data will be stored in $conf['sess_table']
//   If not, data is stored in the table defined below,
//     while session id information is also saved to 
//     the session database defined above.
//
//$conf['sess_data_host'] = "localhost";
//$conf['sess_data_db'] = "ampache";
//$conf['sess_data_table'] = "session";
//$conf['sess_data_idcol'] = "id";
//$conf['sess_data_data'] = "value";
//$conf['sess_data_user'] = "music";
//$conf['sess_data_pass'] = "Music!";
//$conf['sess_data_expirecol'] = "expire";

// Note that the 'length' column is stored in the session id database,
//   not the 'data' database
//   This is so the app the creates the initial session controls the
//     timeout.
$conf['sess_data_length'] = "length";


// The name given to the database handles managed by libglue
//   sess_id_hname is used for the primary session id database
//   sess_id_dname is used when a second database is storing session
//     data separately.
//
$conf['sess_id_hname'] = "sess_id_dbh";
$conf['sess_id_dname'] = "sess_data_dbh";

// Length of session, in seconds
//
$conf['sess_length'] = 9000;

// If this is set to 'persistent, libglue maintains a database connection
//   across page loads
$conf['sess_dbhandle'] = "notpersistent"; // or something not persistent


// A name for your session.  Should be different for every authentication
//     mechanism you have.
$conf['sess_name'] = "application_name";


//
////////////////////////////////////////////////////////////////////////////////


// Register the config information:
libglue_param($conf);


// This function manages the config data for libglue.
// If called with a string:
//     libglue_param('sess_name')
// it will try to return the value set for that key.
//
// Pass in the optional $clobber=1 if you don't care 
//     about overwriting previous settings
//
function libglue_param($param,$clobber=0)
{
	static $params = array();
	if(is_array($param))
	//meaning we are setting values
	{
		foreach ($param as $key=>$val)
		{
			if(!$clobber && isset($params[$key]))
			{
				echo "Error: attempting to clobber $key = $val\n";
				exit();
			}
			$params[$key] = $val;
		}
		return true;
	}
	else
	//meaning we are trying to retrieve a parameter
	{
		if(isset($params[$param]))
                {
                    return $params[$param];
                }
		else return false;
	}
}

// Authentication functions for ldap and mysql:
require_once $libglue_path . "/auth.php";

// Session management functions:
require_once $libglue_path . "/session.php";

// Help class for use in your web pages:
/*require_once $libglue_path . "/help.php";*/

// Error class definition:
/*require_once $libglue_path . "/error.php";*/

// Initialize the database handle used by libglue.
require_once $libglue_path . "/dbh.php";

?>
