<?php
/*

 $Id: user.php,v 1.47 2003/08/14 16:32:46 vollmerk Exp $
 $Source: /a1/cvsroot/maint/modules/class/user.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header User Class
	This is the base user class which will be stored in the session
	information for each connecting user.

*/

class User {
	var $username;
	var $fullname;
	var $ui_size;
	var $list_view;
	var $last_seen = 0;
	var $color_template;
	var $host_view;

	var $is_admin = false;
	var $is_zone_admin = false;
	var $is_user = false;
	var $is_guest = false;
		
	var $zones; //array containing zones and access levels

	var $preferred_zone;
	var $current_zone;

	// this may or may not get set based on what zone we're in

	var $debug = false;
	var $view = false;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function User ( $uname, $fname = '', $login = 0,$notreal=false) {
		global $conf;
		$this->username = $uname;
		$this->fullname = $fname;

		$info = $this->get_info();
		$this->preferred_zone = $info->preferred_zone;
		$this->ui_size        = $info->ui_size;
		$this->list_view      = $info->list_view;
		$this->last_seen      = $info->last_seen;
		$this->color_template = $info->color_template;
		$this->host_view      = $info->host_view;
		
		//check to see if their color template if different
		if ($this->color_template != $conf['default_color_template'] AND !($notreal) ) {
			$conf['color'] = new Color($this->color_template);
		} 

		//if there isn't info and we are loging in then add new information
		if (!$info and $login) {
			$time = time();
			$zone = $this->zones();
			$zone_id = $zone[0]->id;
			$default_template = $conf['default_color_template'];
			$sql = "INSERT INTO user (username,last_seen,preferred_zone,color_template) VALUES ('$uname', '$time','$zone_id','$default_template')";
			$db_result = mysql_query($sql, $conf['dbh']);
			$info = $this->get_info($uname);
		}

			

		$this->check_admin();

		// if there is a zone set then use it, else use preferred...
		if ($conf['zone']->id) { 
			$zone_id = $conf['zone']->id; 
		} 
		elseif ($this->has_read_access($this->preferred_zone) ) { 
			$zone_id = $this->preferred_zone; 
		}
		else { 
			$zones = $this->zones();
			$zone_id = $zones[0];
		}

		//if they are logging it set the access level, and update last seen
		if ($login) {
			$this->set_access_level($zone_id); 
			$this->set_last_seen();
		}

	
	} // User

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM user WHERE username='$this->username'";
		$db_result = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_result);
	} // get_info

	/*!
		@function get_level
		@discussion get the access level in an init 
			    based on passed zone
	*/
	function get_level($zone=0) { 
		global $conf, $user;

		if (!$zone) { $zone = $conf['zone']->id; }

		if ($user->is_admin) { return 100; }

		$sql = "SELECT level FROM zone_user WHERE username='" . $this->username . "' AND zone='$zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		return $results->level;

	} // get_level

	//get the last object that they updated 
	function get_last_updated_object() {
		global $conf;

		$sql = "SELECT * FROM object_history WHERE username='$this->username' ORDER BY date DESC";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);
		
		
		/* Now do work depending on what type of object it is */
		if ($results->object_type == 'host') {
			$results->object = new Host($results->object_id);
			$results->name = $results->object->hostname;
			$results->link = $conf['web_path'] . "/host.php?action=show_host&amp;host_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'domain') {
			$results->object = new Domain($results->object_id);
			$results->name = $results->object->name;
			$results->link = $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'subnet') {
			$results->object = new Subnet($results->object_id);
			$results->name = $results->object->name;
			$results->link = $conf['web_path'] . "/domain.php?action=show_subnet&amp;subnet_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'cname') {
			$results->object = new Cname($results->object_id);
			$results->name = $results->object->hostname;
			$results->link = $conf['web_path'] . "/cname.php?action=show_cname&amp;cname_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'mx') {
			$results->object = new Mx($results->object_id);
			$results->name = $results->object->hostname;
			$results->link = $conf['web_path'] . "/mx.php?action=show_mx&amp;mx_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'zone') {
			$results->object = new Zone($results->object_id);
			$results->name = $results->object->name;
			$results->link = $conf['web_path'] . "/zone.php?action=show_zone&amp;zone_id=" . $results->object_id;
		}
		elseif ($results->object_type == 'pointer') {
			$results->object = new Pointer($results->object_id);
			$results->name = $results->object->type . " pointer (" .$results->object->hostname . " <--> " . $results->object->ip->ip_addr . ")";
			$results->link = $conf['web_path'] . "/pointer.php?action=show_pointer&amp;pointer_id=" . $results->object_id;
		}
	return $results;

	} //get_last_updated_object

	// returns the zones for this user as objects
	// if the user is an admin user then it will return all of the zones
	function zones () {
		global $conf;

		if ( $this->is_admin ) {
			$sql = "SELECT id FROM zone ORDER BY name";
		}

		/* it ain't pretty but we don't have sub-selects!! */
		/* this funky sql does the trick of sorting the select by zone.name */
		else {
			$sql = "SELECT DISTINCT zone_user.zone
				FROM zone_user,zone WHERE zone_user.zone=zone.id AND
				zone_user.username='$this->username' ORDER BY zone.name";
		}
		$db_result = mysql_query($sql, $conf['dbh']);
		$zones = array();

		while ( $z = mysql_fetch_row($db_result) ) {
			$zone = new Zone($z[0]);
			$zones[] = $zone;
		}

		return $zones;
	} // zones

	/*!
		@function get_zones_select
		@discussion specificly for the zone_selects, simplyfied select
			    to try to make it snapier
	*/
	function get_zones_select() {
		global $conf;

		if ($this->is_admin) {
			$sql = "SELECT id,name FROM zone ORDER BY name";
		}

		// Away ugly select statement
		else {
			$sql = "SELECT zone.id,zone.name FROM zone_user,zone WHERE zone_user.zone=zone.id AND zone_user.username='$this->username' ORDER BY zone.name";
		}

		$db_results = mysql_query($sql, $conf['dbh']);

		while ($z = mysql_fetch_object($db_results)) {
			$zones[] = $z;
		}

		return $zones;

	} // get_zones_select

	//get all zones $this is a zone_admin in
	function get_zone_admin_zones() {
		global $conf;

		$sql = "SELECT zone_user.zone FROM zone_user WHERE level='50' AND username='$this->username'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
			$results[] = new Zone($r->zone);
		}

	return $results;

	} //get_zone_admin_zones

	//this function checks/sets the information if you are a guest
	//or a full blown admin
	function check_admin() {
		global $conf; 

                // check to see if they are an admin
                $sql = "SELECT level FROM zone_user WHERE username='$this->username' AND level=100";
                $db_result = mysql_query($sql, $conf[dbh]);

                $results = mysql_fetch_object($db_result);

               if ($results->level == 100) {
	               $this->is_admin = true;
               }
	
		else {
			$this->is_admin = false;
		}

	} //check_admin

	/*!
		@function check_mysql_auth_name
		@discussion Checks to see if this username exists as a mysql user
	*/
	function check_mysql_auth_name($username) {
		global $conf;


		$sql = "SELECT username FROM user WHERE username='$username' AND type='mysql'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		return $results->username;

	} // check_mysql_auth_name

	// this translates the int value into a text representation of the level (for the users)
	function access_level($level) {
		global $conf;

		if ($level == 100) { $results = "Full Admin"; }
		elseif ($level == 50) { $results = "Zone Admin"; }
		elseif ($level == 25) { $results = "Zone User"; }
		elseif ($level == 5) { $results = "Zone Guest"; }
		
	return $results;

	} //access_level

	// tells us if the user has at least READ access (used for setting zones on load)
	function has_read_access ( $zone_id ) {
		global $conf;
		
		if ($this->is_admin) {
			return true;
		}

		$sql = "SELECT id FROM zone_user WHERE username='$this->username' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (mysql_fetch_row($db_results) ) {
			return true;
		}
		else {
			return false;
		}

	} //has_read_access


	// tells us if this user has access to the specified zone
	function has_access ( $zone_id ) {
		global $conf;

		// if they are an admin let them do as they please
		if ( $this->is_admin ) {
			return true;
		}
		elseif ($this->is_guest) {
			return false;
		}

		$sql = "SELECT id,level FROM zone_user WHERE username='$this->username' AND zone='$zone_id'";
		$db_result = mysql_query($sql, $conf['dbh']);

		if ( $r = mysql_fetch_array($db_result) ) {
			return $r['level'];
		}
		else {
			return false;
		}
	}

	/*!
		@function is_setup_user
		@discussion this checks to see if this account is the
			    "admin" account	    
	*/
	function is_setup_user() { 
		global $conf;

		if ($this->username === "admin") { 
			$sql = "SELECT username FROM user WHERE username='admin' AND password=password('changeme')";
			$db_results = mysql_query($sql, $conf['dbh']);
			
			if (mysql_fetch_row($db_results)) { 
				return true;
			}
			else {
				return false;
			}
		}

		return false;

	} // is_setup_user

	/*!
		@function create_mysql_user
		@discussion this creates a new mysql user, mysql_auth() must be on
	*/
	function create_mysql_user($username, $password) {
		global $conf, $user;
	
		if ($user->is_admin AND $conf['ui']->mysql_auth()) {
			$sql = "INSERT INTO user (username,password,type,color_template) VALUES ('$username',PASSWORD('$password'),'mysql','onid')";
			$db_results = mysql_query($sql, $conf['dbh']);
			$user_id = mysql_insert_id();
		}

		return $user_id;

	} // create_mysql_user

	/*!
		@function add_full_admin
		@discussion adds a full admin user
	*/
	function add_full_admin($username) {
		global $conf;
	
		// first make sure they aren't a full admin already
		$user_obj = new User($username);
		if (!$user_obj->is_admin) {
			$sql = "INSERT INTO zone_user SET username='$username', level='100', zone='0'";
			$db_results = mysql_query($sql, $conf['dbh']);
		} // if they are an admin


	} // add_full_admin

	//this sets the user level, used when you change zones
	function set_access_level($zone_id) {
		global $conf, $user;

		$sql = "SELECT level FROM zone_user WHERE zone='$zone_id' AND username='$this->username'";

                $db_result = mysql_query($sql, $conf['dbh']);
                $user_level = mysql_fetch_object($db_result);
	
                if ( $this->is_admin ) {
                        $this->is_zone_admin = true;
                        $this->is_user       = false;
                        $this->is_admin      = true;
                        $this->is_guest      = false;

                }
                elseif ( $user_level->level == '50' )
                {
                        $this->is_zone_admin = true;
                        $this->is_user       = false;
                        $this->is_admin      = false;
                        $this->is_guest      = false;

                }
                elseif ( $user_level->level == '25' )
                {
                        $this->is_zone_admin = false;
                        $this->is_user       = true;
                        $this->is_admin      = false;
                        $this->is_guest      = false;

                }
                elseif ( $user_level->level == '5' )
                {
                        $this->is_zone_admin = false;
                        $this->is_user       = false;
                        $this->is_admin      = false;
                        $this->is_guest      = true;
                }

	return;	

	} //set_access_level

	/*!
		@function set_passwd
		@discussion Sets a new password for the user
	*/
	function set_passwd($passwd,$username=0) {
		global $conf, $user;

		if (!$username) { $username = $user->username; }
		
		// Make sure they are either the user, or a admin
		if ($user->username != $username AND !$user->is_admin) { 
			return false; 
		}

		// Make sure that they currently do not have a blank passwd
		// and that they aren't trying to set a blank one
		$sql = "SELECT username FROM user WHERE username='$username' AND password=''";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		if (strlen($passwd) < 8 OR mysql_fetch_row($db_results)) { 
			return false;
		} 
	
		// Yea we've passed the test they can set their password now
		$sql = "UPDATE user SET password=password('$passwd') WHERE username='$username'";
		$db_results = mysql_query($sql, $conf['dbh']);

		return true;	

	} // set_passwd

	/*!
		@function set_from_db()
		@discussion rebuilds the user object from information
			    stored in the $_SESSION global
	*/
	function set_from_db() {
		global $conf;

		$sql = "SELECT * FROM user WHERE username='" . $this->username . "'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_array($db_results);
		
		// Set $this back up.. from session data
		foreach ($results as $key => $value) {
			$this->{$key} = $value;
		}

	} // set_from_session

	/*!
		@function check_password
		@discussion this checks the current password of a local user
			    this is used by the password change tools
	*/
	function check_password($username,$password) { 
		global $conf;

		$sql = "SELECT username FROM user WHERE username='$username' AND password=PASSWORD('$password')";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (!mysql_fetch_row($db_results)) { 
			return false;
		}
		
		return true;

	} // check_password

	//return the level of access they have for a specified zone
	//used for showing users
	function get_access_level($zone_id) {
		global $conf;
	
		$sql = "SELECT * FROM zone_user WHERE zone='$zone_id' AND username='$this->username'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		return $results->level;

	} //get_access_level

	//check $name in ldap to assure it's there (for new user additions)
	function check_auth_name($name) { 
		global $conf;
		
		//first off are we in debug mode? if so get out of here
		if ($conf['debug'] == 'true') { return true; }

		if ($ldap_link = ldap_connect($conf['ldap_host'])) {
			//now let's try to bind to the server
			if ($bind = ldap_bind($ldap_link, "uid=" .$conf['ldap_auth_dn'], $conf['ldap_pass'])) {

				//now it's time to search
				$sr = ldap_search($ldap_link, 'ou=People,o=orst.edu', "(uid=$name)");		
				$info = ldap_get_entries($ldap_link, $sr);
				if ($info["count"]) {
					@ldap_close($ldap_link);
					return true;
				}
				else {
					//unable to find user
					$error .= "The username $name was not found, please try again.<br />";
				     }					

			}
			else { 
				// it be broken captin
				$error .=  $conf['ldap_auth_dn'] . " was unable to connect to ldap server<br />";
			}
		
		} 
		else {
			$error .= "Unable to connect to " . $conf['ldap_host'] . "<br />";
			
		}
	@ldap_close($ldap_link);

	if ($error) { 
		$conf['error']->error_state = true;
		return false;
	}
	return true;

	} //check_auth_name

	function set_preferred_zone ( $zone_id ) {
		global $conf;

		$sql = "UPDATE user SET preferred_zone=$zone_id WHERE username='$this->username'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$this->preferred_zone = $zone_id;

	} // preferred_zone

	//set your host_view preference
	function set_host_view($host_view) {
		global $conf;

		$sql = "UPDATE user SET host_view='$host_view' WHERE username='$this->username'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$this->host_view = $host_view;

	} //set_host_view
	
	function set_ui_size ( $size ) {
		global $conf;

		$sql = "UPDATE user SET ui_size=$size WHERE username='$this->username'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$this->ui_size = $size;
	}

	function set_list_view ( $list_view ) {
		global $conf;

		$sql = "UPDATE user SET list_view=$list_view WHERE username='$this->username'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$this->list_view = $list_view;
	}
		
	function set_color_template  ( $template ) {
		global $conf;
	
		$sql = "UPDATE user SET color_template='$template' WHERE username='$this->username'";
		$db_results = mysql_query($sql, $conf['dbh']);
	
		$this->color_template = $template;

	} //set_color_template

	function set_last_seen ( $time = 0 ) {
		global $conf;

		// if they don't specify a time, just use the current time
		if ( ! $time ) {
			$time = time();
		}

		$sql = "UPDATE user SET last_seen=$time WHERE username='$this->username'";
		$db_result = mysql_query($sql, $conf['dbh']);
	} // last_seen

	/*!
		@function delete
		@discussion deletes $this local user
	*/
	function delete() {
		global $conf, $user;

		if ($user->is_admin) { 
			$sql = "DELETE FROM user WHERE username='$this->username'";
			$db_results = mysql_query($sql, $conf['dbh']);
		} // is admin

	} // delete

	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print_r(get_object_vars($this));
	}

	function _return_show() {
		return var_dump($this);
	}
	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
}

?>
