<?php

/*

 $Id: show_options.inc,v 1.19 2003/08/29 20:22:19 vollmerk Exp $
 $Source: /a1/cvsroot/maint/templates/show_options.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
        @header Show Options Template
	Show a listing of the DHCP options for this workgroup or
	subnet.  They use the same option types.

*/

if ($action ==='host') { $host = new Host($type_id); }

if ($type == 'workgroup') { 
	$object = new Workgroup($type_id);
}
elseif ($type == 'subnet') { 
	$object = new Subnet($type_id);
}
elseif ($type == 'host') { 
	$object = $host;
	$object->name = $host->hostname;
}

?>
<p class="header2">Viewing DHCP Options for the <?= $object->name . " " .  $type; ?></p>
<?
$items = array();

if ($action === 'host' && ( $user->is_admin || $user->has_access($host->zone->id) >= 50)   ) { 
	$items[] = "<a href=\"" . $conf['web_path'] . "/option.php?action=show_create_host&amp;" . $type . "_id=$type_id&amp;type=$type\">Add a new DHCP Option to this $type</a>";
	$items[] = "<a href=\"" . $conf['web_path'] . "/$type.php?action=show_host&amp;host_id=$type_id\">View the $type assoicated with this Option</a>";
}
elseif ($action != 'view' AND $action != 'show_global_options') { 
	$items[] = "<a href=\"" . $conf['web_path'] . "/option.php?action=show_create&amp;" . $type ."_id=$type_id\">Add a new DHCP Option to this $type</a>";
	if ($user->is_admin) { $items[] = "<a href=\"" . $conf['web_path'] . "/" . $type . ".php?action=edit&amp;" . $type . "_id=$type_id\">View the $type assoicated with this Option</a>"; }
}

$conf['ui']->display_top_widget($items);

show_template('tborder'); 
if ( $user->view->limit ) {
	$conf['ui']->show_list_header( count($options) );
}

?>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr align="center" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
    		<td title="<? $conf['help']->title('options_dhcp'); ?>">DHCP Option</td>
    		<td title="<? $conf['help']->title('options_value'); ?>">Entered Value</td>
		<td title="<? $conf['help']->title('options_value'); ?>">Final Value</td>
		<td title="<? $conf['help']->title('options_scope'); ?>">Type</td>
                <td>Action</td>
	</tr>

<?
if (count($options)) { 
foreach ($options as $option) {
if ($option->type =='host') { 
	$option->hostname = $object->name;
	$option->ip->ip_addr = $object->ip->ip_addr;
	$option->ha = $object->ha;
}
if ($option->type =='workgroup' && $_REQUEST['host_id']) {
	$host = new Host($_REQUEST['host_id']);
	$option->hostname = $host->name;
	$option->ip->ip_addr = $host->ip->ip_addr;
	$option->ha = $host->ha;
}
?>
	<tr align="center" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td><? $conf['ui']->display_field($option->dhcp_option_name); ?></td>
		<td><? $conf['ui']->display_field($option->value); ?></td>
		<td><? $conf['ui']->display_field($conf['ui']->parse_dhcp_option($option->value,$option)); ?></td>
		<td><? $conf['ui']->display_field($option->type); ?></td>
		<td>
			<? if ($action == 'show_global_options') { ?>
			<a href="<?= $conf['web_path']; ?>/option.php?action=edit_global&amp;option_id=<?= $option->id; ?>&amp;type=<?= $type; ?>">Edit</a> | 
			<a href="<?= $conf['web_path']; ?>/option.php?action=delete_global&amp;option_id=<?=  $option->id ?>&amp;type=<?= $type ?>">Delete</a>			
			<? } elseif ($action == 'host') { ?>
			<a href="<?= $conf['web_path']; ?>/option.php?action=show_edit_host&amp;option_id=<?= $option->id; ?>&amp;type=<?= $type; ?>">Edit</a> | 
			<a href="<?= $conf['web_path']; ?>/option.php?action=delete_host&amp;option_id=<?=  $option->id ?>&amp;zone_id=<?= $host->zone->id; ?>&amp;type=host&amp;host_id=<?= $host->id; ?>">Delete</a>
			<? } elseif ($action != 'view') { ?>
			<a href="<?= $conf['web_path']; ?>/option.php?action=edit&amp;option_id=<?=  $option->id ?>&amp;type=<?=  $type ?>">Edit</a> |
			<a href="<?= $conf['web_path']; ?>/option.php?action=delete&amp;option_id=<?=  $option->id ?>&amp;type=<?= $type ?>&amp;type_id=<?= $type_id ?>&amp;zone_id=<?= $conf['zone']->id; ?>">Delete</a>
			<? } else { ?>
			No Actions
			<? } ?>
		</td>
	</tr>
<?
} // foreach

} // if there are options

else {
?>
	<tr align="center" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td colspan="5" class="fatalerror">No Workgroup Options Found</td>
	</tr>
<?
} // else no options there
?>

</table>

<?

if ( $user->view->limit ) {
	$conf['ui']->show_list_header($total_subnets[0]);
}
show_template('bborder'); 
?>

